

###########################################################################
# PROCEDURE: do_foo
#
# DESCRIPTION: Run a little test code, not part of the regular pipeline.
#
# RETURNS
#    0        if all goes well
#    1        if an error occurs
#
proc do_foo { } {

  set debug 0

  set star_id 0

  for { set chip 0 } { $chip < 9 } { incr chip } {
    for { set i_row 0 } { $i_row < 4 } { incr i_row } {
      set row [expr 439+($i_row*878)]
      for { set i_col 0 } { $i_col < 4 } { incr i_col } {
        set col [expr 439+($i_col*878)]
    
        if { [chip_to_radec $chip $row $col ra dec] != 0 } {
          puts stderr "do_foo: chip_to_radec fails "
        }
        puts [format "chip %3d  %4.0f %4.0f  %10.5f %10.5f " \
                   $chip $row $col $ra $dec ]

if { 1 } {
        # create a line for a star of type A0V and mag 20
        set mag 20.0
        set sptype "a0v"
        set color -0.172
        set dummy_num 0.00
        set dummy_str "QQ"
        set bmag [expr $mag+($color*0.5)]
        set rmag [expr $mag-($color*0.5)]
        set line [format "%6d %8.6f %11.6f %11.6f %5s %11.6f %11.6f %6.2f %6.2f %8.3f " \
               $star_id $dummy_num $ra $dec $dummy_str $ra $dec \
               $bmag $rmag $dummy_num]
        puts $line
        incr star_id
}

        # create a line for a star of type G0V and mag 20
if { 1 } {
        set mag 20.0
        set sptype "g0v"
        set color  0.720
        set dummy_num 0.00
        set dummy_str "QQ"
        set bmag [expr $mag+($color*0.5)]
        set rmag [expr $mag-($color*0.5)]
        set line [format "%6d %8.6f %11.6f %11.6f %5s %11.6f %11.6f %6.2f %6.2f %8.3f " \
               $star_id $dummy_num $ra $dec $dummy_str $ra $dec \
               $bmag $rmag $dummy_num]
        puts $line
        incr star_id
}

if { 1 } {
        # create a line for a star of type M0V and mag 20
        set mag 20.0
        set sptype "m0v"
        set color  2.022
        set dummy_num 0.00
        set dummy_str "QQ"
        set bmag [expr $mag+($color*0.5)]
        set rmag [expr $mag-($color*0.5)]
        set line [format "%6d %8.6f %11.6f %11.6f %5s %11.6f %11.6f %6.2f %6.2f %8.3f " \
               $star_id $dummy_num $ra $dec $dummy_str $ra $dec \
               $bmag $rmag $dummy_num]
        puts $line
        incr star_id
}


      }

    }
  }

    

  # Now the IR chips
#
# use these lines if you want just 2x2=4 stars per IR chip
#  for { set chip 9 } { $chip < 18 } { incr chip } {
#    for { set i_row 0 } { $i_row < 2 } { incr i_row } {
#      set row [expr 768+($i_row*1024)]
#      for { set i_col 0 } { $i_col < 2 } { incr i_col } {
#        set col [expr 768+($i_col*1024)]
# (the following just to placate stupid TCL parser)
#      }
#    }
#  }
#
# or these lines to get the same 4x4=16 stars per IR chip as in visible chips
  for { set chip 9 } { $chip < 18 } { incr chip } {
    for { set i_row 0 } { $i_row < 4 } { incr i_row } {
      set row [expr 439+($i_row*878)]
      for { set i_col 0 } { $i_col < 4 } { incr i_col } {

        set col [expr 439+($i_col*878)]
        if { [chip_to_radec $chip $row $col ra dec] != 0 } {
          puts stderr "do_foo: chip_to_radec fails "
        }
        if { $debug > 5 } {
          puts [format "chip %3d  %4.0f %4.0f  %10.5f %10.5f " \
                   $chip $row $col $ra $dec ]
        }

if { 1 } {
        # create a line for a star of type A0V and mag 20
        set mag 20.0
        set sptype "a0v"
        set color -0.172
        set dummy_num 0.00
        set dummy_str "QQ"
        set bmag [expr $mag+($color*0.5)]
        set rmag [expr $mag-($color*0.5)]
        set line [format "%6d %8.6f %11.6f %11.6f %5s %11.6f %11.6f %6.2f %6.2f %8.3f " \
               $star_id $dummy_num $ra $dec $dummy_str $ra $dec \
               $bmag $rmag $dummy_num]
        puts $line
        incr star_id
}

        # create a line for a star of type G0V and mag 20
if { 1 } {
        set mag 20.0
        set sptype "g0v"
        set color  0.720
        set dummy_num 0.00
        set dummy_str "QQ"
        set bmag [expr $mag+($color*0.5)]
        set rmag [expr $mag-($color*0.5)]
        set line [format "%6d %8.6f %11.6f %11.6f %5s %11.6f %11.6f %6.2f %6.2f %8.3f " \
               $star_id $dummy_num $ra $dec $dummy_str $ra $dec \
               $bmag $rmag $dummy_num]
        puts $line
        incr star_id
}

if { 1 } {
        # create a line for a star of type M0V and mag 20
        set mag 20.0
        set sptype "m0v"
        set color  2.022
        set dummy_num 0.00
        set dummy_str "QQ"
        set bmag [expr $mag+($color*0.5)]
        set rmag [expr $mag-($color*0.5)]
        set line [format "%6d %8.6f %11.6f %11.6f %5s %11.6f %11.6f %6.2f %6.2f %8.3f " \
               $star_id $dummy_num $ra $dec $dummy_str $ra $dec \
               $bmag $rmag $dummy_num]
        puts $line
        incr star_id
}

      }
    }
  }


  return 0
}

